/*                                                     project Gemini 
----------------------------------------------------------------------
    Rꏈ [eBeB gW[
      $Id: nlputil.c,v 1.10 2002/11/21 13:50:33 abe Exp $

       Copyright (C) 2001-2002, SATO Lab. <http://mi.cs.titech.ac.jp> 
----------------------------------------------------------------------
*/
#define DEFINE_BODY
#include "nlputil.h"
#include "stolcke.h"
#include <stdarg.h>


/*   O[oϐ
------------------------------------------------------------------- */
VALUE rb_mExt;
VALUE rb_eNLPException;

ID id_id;
ID id_plus;
ID id_mult;
ID id_size;
ID id_last;
ID id_first;
ID id_length;
ID id_typestring;

/*   gW[̏|Cg
------------------------------------------------------------------- */

void Init_nlputil ( void )
{
    /* KvȃIuWFNg𓾂
    ---------------------------------------- */
    rb_eNLPException = rb_const_get( rb_cObject, rb_intern( "NLPException" ) );
    if( NIL_P( rb_eNLPException ) )
        rb_raise( rb_eRuntimeError, "class `NLPException' is not defined." );
    
    rb_mExt = rb_define_module( "Ext" );
    
    /* W[̏ (邱)
    ---------------------------------------- */
    init_grammar();
    init_chart();
    init_itemset();
    init_strparse();
    init_eparser();
    init_pcfg();
    init_stolcke();
    
    /* ʎq ID 𓾂
    ---------------------------------------- */
    id_id    = rb_intern( "id" );
    id_plus  = rb_intern( "+" );
    id_mult  = rb_intern( "*" );
    id_size  = rb_intern( "size" );
    id_last  = rb_intern( "last" );
    id_first = rb_intern( "first" );
    
    id_length     = rb_intern( "length" );
    id_typestring = rb_intern( "typestring" );
}


/*   Ruby f[^p[eBeB
------------------------------------------------------------------- */

int ru_is_instance_of ( VALUE obj, VALUE klass )
{
    if( !rb_obj_is_instance_of( obj, klass ) )
        rb_raise( rb_eNLPException, "Argument type is not %s.", rb_class2name(klass) );
    
    return 1;
}


/*   fobOp[eBeB
------------------------------------------------------------------- */

int errp ( const char * format, ... )
{
    va_list ap;
    
    va_start( ap, format );
    return vfprintf( stderr, format, ap );
}

int defp ( const char * format, ... )
{
    va_list ap;
    
    va_start( ap, format );
    return vfprintf( stdout, format, ap );
}


