/*                                                     project Gemini 
----------------------------------------------------------------------
    ͂̕⏕
      $Id: strparse.c,v 1.12 2002/08/02 04:45:16 abe Exp $

       Copyright (C) 2001-2002, SATO Lab. <http://mi.cs.titech.ac.jp> 
----------------------------------------------------------------------
*/
#define DEBUGSW 0
#include "nlputil.h"
#include <ctype.h>


#define  SKIP_WS(PTR)  STRPARSE_SKIP_WS(PTR)


/*   xOt: pXH
----------------------------------------------------------------------
 - ͑Ώۂ
    +- (:...:) @... @...
   ̂悤ȍs
*/

VALUE strparse_sgraph_path_p ( const char * p )
{
    VALUE volatile localpath;
    const char *q, *r;
    int    n;
    
    /* /\s+\+-+/ */
    if( *p != ' ' && *p != '\t' )
        return Qnil;
    ++p;
    SKIP_WS( p );
    
    if( p[0] != '+' && p[1] != '-' )
        return Qnil;
    for( p += 2; *p == '-'; ++p )
        ;
    
    /* pXm */
    localpath = rb_ary_new();
    
    /* m[hEĂ */
    while( *p != '\n' && *p != '\0' ) {
        SKIP_WS( p );
        if( *p == '\n' || *p == '\0' )
            break;
        
        if( p[0] == '(' && p[1] == ':' ) {
            /* (: ... :) */
            p += 2;
            SKIP_WS( p );
            q = p;
            while( p[0] != ':' || p[1] != ')' ) {
                if( *p == '\0' )
                    rb_raise( rb_eNLPException, "Supportgraph syntax error. (no ``:)'')" );
                ++p;
            }
            r = p;
            while( r > q && (r[-1] == ' ' || r[-1] == '\t') )
                --r;
            rb_ary_push( localpath, rb_str_new( q, r-q ) );
            p += 2;
        }
        else if( p[0] == '@' ) {
            /* @... */
            ++p;
            n = 0;
            
            /* ꌅ */
            if( !('0' <= p[0] && p[0] <= '9') )
                return Qnil;
            n += (*(p++) - '0');
            
            /* 񌅈ȍ~ */
            while( '0' <= p[0] && p[0] <= '9' ) /* ASCIIˑǁcˁH */
                n = n*10 + (*(p++) - '0');
            
            rb_ary_push( localpath, INT2FIX(n) );
        }
        else {
            rb_raise( rb_eNLPException, "Supportgraph syntax error. (rest string=%s)", p );
        }
    }
    
    return localpath;
}

static VALUE strparse_sgraph_path_p_method ( VALUE module, VALUE line )
{
    VALUE volatile v;
    
    Check_Type( line, T_STRING );
    
    v = strparse_sgraph_path_p( RSTRING(line)->ptr );
    
    return rb_ary_new3( 2, INT2FIX(RARRAY(v)->len), v );
}


/*   I[LEI[L̉
------------------------------------------------------------------- */
const char * strparse_parse_cat ( const char * ptr, const char * * cat, int * len )
{
    int  l, r;
    
    SKIP_WS( ptr );
    if( *ptr == '\0' )
        return NULL;
    
    *cat = ptr; /* cat: L̊Jnʒu */
    if( *ptr == '<' ) {
        /* I[L (<  > lXgĂĂ͂ł悤ɂ) */
        ++ptr;
        l = 1, r = 0;
        while( l != r ) {
            switch( *(ptr++) ) {
            case '\0':
                rb_raise( rb_eNLPException, "Rule: Syntax error (``>'' is not found)" );
                break;
            case '<':
                ++l;
                break;
            case '>':
                ++r;
                break;
            case '-': /* <X | <A> --> <B>> ̂悤Ȃ̂͂邽߂̑Ώ (vȂIH) */
                if( ptr[0] == '-' && ptr[1] == '>' )
                    ptr += 2;
                break;
            }
        }
    }
    else {
        /* I[L̈ꕶڂ̓At@xbgnoCĝ */
        if( isascii(*ptr) && !isalnum(*ptr) )
            return NULL;
        
        /* I[L͋󔒂 < ܂ */
        while( *ptr != ' ' && *ptr != '\t' && *ptr != '<' && *ptr != '\n' && *ptr != '\0' ) {
            /*  '|' ͏O */
            if( *ptr == '|' )
                rb_raise( rb_eNLPException, "Rule: Cannot use declaration of condition." );
            ++ptr;
        }
    }
    *len = ptr - *cat; /* len: L̒ (<  > ܂) */
    if( *len == 0 )
        return NULL;
    
    return ptr;
}


/*   @K
----------------------------------------------------------------------
 - ͑Ώۂ
    <...> --> <...> ... <...>
   ̂悤ȍs
 - ex  terms ɂ͋K̏I[ɂȂ镶i[w肷B
   Ƃ "," w肷 ',' kI[ƂB
 - len  NULL ȊȌꍇɂ͕̒i[B
*/
VALUE strparse_parse_rule ( const char * p )
{
    VALUE volatile ret = rb_ary_new();
    const char * head;
    int len, errflag;
    
    SKIP_WS( p );
    if( *p == '\0' || *p == '\n' )
        return ret;
    
    /*  */
    p = strparse_parse_cat( p, &head, &len );
    if( !p )
        return ret;
    rb_ary_push( ret, rb_str_new( head, len ) );
    
    /* --> */
    SKIP_WS( p );
    errflag = 0;
    if( *p != '-' )
        errflag = 1;
    else {
        for( ++p; *p == '-'; ++p ) ;
        if( *p != '>' )
            errflag = 1;
        ++p;
    }
    if( errflag )
        rb_raise( rb_eNLPException, "Syntax error. (Rule: not found ``-->'')" );
    
    /* E */
    while( p = strparse_parse_cat( p, &head, &len ) )
        rb_ary_push( ret, rb_str_new( head, len ) );
    
    return ret;
}

static VALUE strparse_parse_rule_method ( VALUE module, VALUE line )
{
    line = rb_String( line );
    return strparse_parse_rule( RSTRING(line)->ptr );
}


/*   @K̏CLq
----------------------------------------------------------------------
 - ͑Ώۂ
    \s*(\s*(.+(=.*)?,)*)  (: (a=1,b=2,...) )
   ̂悤ȍsBΉ (  ) ܂Ői߂Ƃŉ͂IB
   ary Ŏz ['a','1','b','2',...] Ɗi[ĂB
   l "  " ň͂܂ĂĂB
*/
const char * strparse_parse_rule_property ( const char * buf, VALUE ary )
{
    const char *p, *q, *r;
    
    Check_Type( ary, T_ARRAY );
    p = buf;
    SKIP_WS( p );
    if( *p != '(' )
        return buf; /* K̐錾ł͂Ȃ */
    ++p;
    
    while( *p != ')' ) {
        /* vpeB */
        SKIP_WS( p );
        for( q = p; *p != '=' && *p != ')' && *p != ' ' && *p != '\t'; ++p ) {
            if( *p == '\0' )
                rb_raise( rb_eNLPException, "Rule property: Syntax error. (``)'' is not found)" );
        }
        if( p == q )
            rb_raise( rb_eNLPException, "Rule property: Syntax error. (property name is not found)" );
        rb_ary_push( ary, rb_str_new( q, p-q ) );
        
        /* vpeBl */
        SKIP_WS( p );
        if( *p == '=' ) {
            ++p;
            SKIP_WS( p );
            
            if( *p == '"' ) {
                ++p; /* '"' ̕ */
                for( q = p; *p != '"'; ++p ) {
                    if( *p == '\0' )
                        rb_raise( rb_eNLPException, "Rule property: Syntax error. (``\"'' is not found)" );
                }
                rb_ary_push( ary, rb_str_new( q, p-q ) );
                ++p; /* '"' ̕ */
            }
            else {
                for( q = p; *p != ',' && *p != ')'; ++p ) {
                    if( *p == '\0' )
                        rb_raise( rb_eNLPException, "Rule property: Syntax error. (``)'' is not found)" );
                }
                for( r = p - 1; r > p && (*r == ' ' || *r == '\t'); --r )
                    ; /* ̋󔒂폜 */
                ++r;
                rb_ary_push( ary, rb_str_new( q, r-q ) );
            }
        }
        else {
            rb_ary_push( ary, Qtrue );
        }
        if( *p == ',' )
            ++p;
    }
    ++p;
    
    return p;
}


/*   \͌ʂ̈ʒuXg
----------------------------------------------------------------------
 - [1,2,3] Ȃ
 - ary ɂ͈ʒũXgݒ肳B
   @K͋Kԍ֐̕ԒlB
*/
VALUE strparse_parse_item_poslist ( const char * p, VALUE ary )
{
    VALUE volatile ret = Qnil;
    const char * q;
    int  n;
    
    Check_Type( ary, T_ARRAY );
    rb_ary_clear( ary );
    
    SKIP_WS( p );
    if( *p != '[' )
        return Qnil;
    ++p;
    
    while( *p != ']' ) {
        SKIP_WS( p );
        
        /* ꌅ */
        n = 0;
        if( !('0' <= *p && *p <= '9') )
            rb_raise( rb_eNLPException, "Invalid item format. (invalid position)" );
        n += (*(p++) - '0');
        
        /* 񌅖ڈȍ~ */
        while( '0' <= *p && *p <= '9' ) {
            n = n*10 + (*(p++) - '0');
        }
        
        SKIP_WS( p );
        switch( *p ) {
        case ',':
            ++p;
        case ']':
            rb_ary_push( ary, INT2FIX(n) );
            break;
        default:
            rb_raise( rb_eNLPException, "Invalid item format. (index separator is not found)" );
        }
    }
    ++p;
    while( *p == ' ' || *p == '\t' )
        ++p;
    
    /* @K̎擾 */
    if( '0' <= *p && *p <= '9' ) {
        n = (*(p++) - '0');
        while( '0' <= *p && *p <= '9' ) {
            n = n*10 + (*(p++) - '0');
        }
        ret = INT2FIX(n);
    }
    else {
        q = p;
        while( *p != '\n' && *p != '\0' )
            ++p;
        ret = rb_str_new( q, p-q );
    }
    
    return ret;
}

static VALUE strparse_parse_item_poslist_method ( VALUE module, VALUE line, VALUE ary )
{
    Check_Type( line, T_STRING );
    
    return strparse_parse_item_poslist( RSTRING(line)->ptr, ary );
}


/*   xOt̃Otԍ
----------------------------------------------------------------------
*/

static VALUE strparse_sgraph_index_p ( VALUE module, VALUE line )
{
    char  *p, *q;
    int    n;
    
    Check_Type( line, T_STRING );
    p = RSTRING(line)->ptr;
    
    /* ^[\s*(\d+?)\s*] */
    if( p[0] != '[' )
        return Qnil;
    ++p;
    
    SKIP_WS( p );
    
    n = 0;
    if( !('0' <= *p && *p <= '9') )
        rb_raise( rb_eNLPException, "Invalid graph index format. (Invalid index)" );
    n += (*(p++) - '0');
    while( '0' <= *p && *p <= '9' )
        n = n*10 + (*(p++) - '0');
    
    SKIP_WS( p );
    
    if( p[0] != ']' )
        rb_raise( rb_eNLPException, "Invalid graph index format. (No ']')" );
    ++p;
    SKIP_WS( p );
    
    /* #... */
    if( *p == '#' ) {
        ++p;
        SKIP_WS( p );
        q = p;
        while( *p != '\0' && *p != '\n' )
            ++p;
        
        return rb_ary_new3( 2, INT2FIX(n), rb_str_new( q, p-q ) );
    }
    
    return rb_ary_new3( 2, INT2FIX(n), Qnil );
}


/*   Ľ`
----------------------------------------------------------------------
*/

int strparse_is_nonterm ( const char * str, long len )
{
    if( len < 0 )
        len = strlen( str );
    
    if( len < 2 ) /* 񕶎ȉł͍\łȂ */
        return 0;
    
    return (str[0] == '<' && str[len-1] == '>');
}

int strparse_is_preterm ( const char * str, long len )
{
    return !strparse_is_nonterm( str, len );
}

VALUE strparse_nonterm_p ( VALUE module, VALUE str )
{
    str = rb_String( str );
    return (strparse_is_nonterm( RSTRING(str)->ptr, RSTRING(str)->len ))? Qtrue: Qfalse;
}

VALUE strparse_preterm_p ( VALUE module, VALUE str )
{
    str = rb_String( str );
    return (strparse_is_preterm( RSTRING(str)->ptr, RSTRING(str)->len ))? Qtrue: Qfalse;
}


/*   FIRST W̋Lq
----------------------------------------------------------------------
 - z񂪕ԂB\͎̒ʂB
    [ FIRST(X)  X, FIRST(X) ̗vf, FIRST(X) ̗vf, ... ]
   ̏ꍇ nil ԂB
*/

VALUE strparse_parse_firstset ( const char * p )
{
    VALUE volatile ary = Qnil;
    const char * catptr;
    int catlen;
    
    SKIP_WS( p );
    
    /* FIRST */
    if( strncmp( p, "first", 5 ) != 0 && strncmp( p, "FIRST", 5 ) != 0 && strncmp( p, "First", 5 ) != 0 )
        return Qnil;
    p += 5;
    SKIP_WS( p );
    
    /* ( X ) */
    if( *p != '(' )
        rb_raise( rb_eNLPException, "Syntax error. (no ``('')" );
    ++p;
    SKIP_WS( p );
    catptr = p;
    while( *p != ' ' && *p != '\t' && *p != ')' ) {
        if( *p == '\0' || *p == '\n' )
            rb_raise( rb_eNLPException, "Syntax error. (no ``)'')" );
        ++p;
    }
    catlen = p - catptr;
    SKIP_WS( p );
    if( *p != ')' )
        rb_raise( rb_eNLPException, "Syntax error. (no ``)'')" );
    ++p;
    SKIP_WS( p );
    
    /* = */
    if( *p != '=' )
        rb_raise( rb_eNLPException, "Syntax error. (no ``='')" );
    ++p;
    SKIP_WS( p );
    
    /* LXg */
    ary = rb_ary_new3( 1, rb_str_new( catptr, catlen ) );
    
    while( *p != '\0' && *p != '\n' ) {
        catptr = p;
        while( *p != ' ' && *p != '\t' && *p != '\n' && *p != '\0' )
            ++p;
        rb_ary_push( ary, rb_str_new( catptr, p - catptr ) );
        SKIP_WS( p );
    }
    
    return ary;
}


/*   StringParser W[̍\z
----------------------------------------------------------------------
*/
void init_strparse ( void )
{
    VALUE  m_strparse;
    
    /* lCeBuŕ̓W[̍쐬 */
    m_strparse = rb_define_module_under( rb_mExt, "StringParser" );
    
    /* W[֐̒` */
    rb_define_module_functions(
        m_strparse,
        
        "sgraph_path?"		, strparse_sgraph_path_p_method, 1,
        
        "parse_rule"		, strparse_parse_rule_method, 1,
        
        "parse_item_poslist"	, strparse_parse_item_poslist_method, 2,
        
        "sgraph_index?"		, strparse_sgraph_index_p, 1,
        
        NULL);
}


